image: ruby:2.7

stages:
  - setup
  - lint
  - projects
  - move

cache:
  key: "$CI_PIPELINE_ID"
  paths:
    - vendor

# TODO: Figure out how to ensure that the installed
# gems are cached in a manner such that they are
# accessible to all future pipeline stages
before_script:
  - bundle config path vendor/bundle
  - bundle install
  - date -u +'%Y-%m-%d_%H%M%S'

after_script:
  - date -u +'%Y-%m-%d_%H%M%S'

install:
  stage: setup
  script:
    - bundle install

rubocop:
  stage: lint
  script:
    - bundle exec rubocop

# Download projects artifact
download:
  stage: projects
  tags:
    - k8s-workloads
  script:
    - 'curl --globoff --header "PRIVATE-TOKEN: $OPS_PRIVATE_TOKEN" "https://gitlab.com/api/v4/projects/23835928/jobs?scope[]=pending&scope[]=running" --output ./jobs.json'
    # TODO: Handle jobs.json and extract latest job id
    - 'curl --location --output artifacts.zip --header "JOB-TOKEN: $CI_JOB_TOKEN" "https://gitlab.example.com/api/v4/projects/23835928/jobs/${latest_job_id}/artifacts"'
    # TODO: Handle artifacts.zip and extract projects.json
  only:
    variables:
      - $CI_PIPELINE_SOURCE == "schedule"
  artifacts:
    paths:
      - ./projects.json

# Schedule all projects to be moved
move:
  stage: move
  tags:
    - k8s-workloads
  script:
    - log_file_path="./log/moves_$(date -u +'%Y-%m-%d_%H%M%S').log"
    - limit="${MOVE_LIMIT:-1}"
    - env="${ENVIRONMENT:-staging}"
    - dry_run="${DRY_RUN:-true}"
    - echo "limit=${limit}"
    - echo "environment=${env}"
    - echo "dry_run=${dry_run}"
    - bundle exec lib/mover.rb --json=./projects.json --limit="${limit}" --environment="${env}" --dry-run="${dry_run}" | tee "${log_file_path}"
  only:
    variables:
      - $CI_PIPELINE_SOURCE == "schedule"
  artifacts:
    paths:
      - ./storage_migrations/*
      - ./log/*
  when: manual

